#include <htc.h>
#include "wait_time.h"
#include "user_define_amfm.h"

#define	DAC_SCK				RA2
#define	DAC_CS				RA3
#define	DAC_SDI				RA4

/*---------- VOLTAGE  ----------*/
void	dac_out_ch1(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	DAC_SCK=0;NOP();
	DAC_CS=1;NOP();
	d0=data << 4;
	d1=0x20;
	DAC_CS=0;NOP();
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			DAC_SDI=1;NOP();
		}
		else{
			DAC_SDI=0;NOP();
		}
		DAC_SCK=1;NOP();
		d1=d1 << 1;
		DAC_SCK=0;NOP();
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			DAC_SDI=1;NOP();
		}
		else{
			DAC_SDI=0;NOP();
		}
		DAC_SCK=1;NOP();
		d0=d0 << 1;
		DAC_SCK=0;NOP();
	}
	DAC_CS=1;NOP();
	DAC_SDI=0;NOP();
}

void	dac_set(unsigned int freq)
{
unsigned long setdata;

	setdata=0;
	if((freq>=31000)&&(freq<32000)){
		setdata=(unsigned long)(freq-31000)*991/1000+1982;
	}
	if((freq>=32000)&&(freq<33000)){
		setdata=(unsigned long)(freq-32000)*500/1000+2974;
	}
	if((freq>=33000)&&(freq<=34400)){
		setdata=(unsigned long)(freq-33000)*557/1000+3473;
		if(setdata>4095){setdata=4095;}
	}
	
	dac_out_ch1((unsigned int)setdata);

}