#include <htc.h>
#include "user_define_amfm.h"

extern unsigned char	preset_no;
extern unsigned int		mhz_no;
extern unsigned char	mode;
extern unsigned char	width;

/*----------EEPROM----------*/
unsigned char E2promRead(unsigned char adr)
{
	EEADR=adr;
	RD=1;
	return(EEDATA);
}

void E2promWrite(unsigned char adr,unsigned char data)
{
	EEADR=adr;
	EEDATA=data;
	
	WREN=1;
	EECON2=0x55;
	EECON2=0xaa;
	
	WR=1;
	while(EEIF==0)
	{
		NOP();
	}
	EEIF=0;
	WREN=0;
}

void	eeprom_init(void)
{
unsigned char	i;

		E2promWrite(0x00,0xa5);

		mhz_no=FREQ_MIN_AIR;		
		E2promWrite(0x0a,(unsigned char)(mhz_no%256));
		E2promWrite(0x0b,(unsigned char)(mhz_no/256));
		E2promWrite(0x08,preset_no);
		E2promWrite(0x05,mode);
		E2promWrite(0x0c,width);
}

void	eeprom_check(void)
{
unsigned int sub0,sub1;

	if(E2promRead(0x00)==0xa5){
		width=E2promRead(0x0c);
		sub0=(unsigned int)E2promRead(0x0a);
		sub1=(unsigned int)E2promRead(0x0b);
		mhz_no=sub0+sub1*256;
		preset_no=E2promRead(0x08);
		mode=eeprom_read(0x05);
	}
	else{
		eeprom_init();
	}
}

void	write_direct(void)
{
		E2promWrite(0x0a,(unsigned char)(mhz_no%256));
		E2promWrite(0x0b,(unsigned char)(mhz_no/256));
		E2promWrite(0x08,preset_no);
		E2promWrite(0x05,mode);
		E2promWrite(0x0c,width);
}
