#define _LEGACY_HEADERS

#include <htc.h>
#include <pic16f886.h>
#include "hitec_c_i2c.h"
#include "lcd_sub.h"
#include "port_init.h"
#include "wait_time.h"
#include "si47xx_amfm.h" 
#include "user_define_amfm.h"
#include "preset.h"
#include "ad.h"
#include "eeprom.h"

__CONFIG(	DEBUGDIS & LVPDIS & FCMDIS & IESODIS & BORDIS
			& DUNPROTECT & UNPROTECT & MCLREN & PWRTEN & WDTDIS & INTIO);
__CONFIG(	0xffff & BORV21);

u8  			cmd[8];
u8  			rsp[15];
u8  			RSSI;
u8  			STC;
u8  			BLTF;
u8  			AFCRL;
u8  			Valid;
u16 			Freq;
u8  			ASNR;
u16 			AntCap;

u8				partNumber;
char 			fwMajor;
char 			fwMinor;
u16 			patchID;
char			cmpMajor;
char			cmpMinor;
char			chipRev;

unsigned int	mhz_no;
unsigned int	mhz_no_m;
unsigned char	mode;
unsigned int	mhz_no_setmode;

unsigned char	preset_no;
unsigned int	preset[PRESET_MAX];

unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw2_cnt;
unsigned char	sw3_key;
unsigned char	sw3_rep;
unsigned char	sw3_cnt;
unsigned char	sw4_key;
unsigned char	sw4_rep;
unsigned char	sw4_cnt;

unsigned char	sw1p;
unsigned char	sw2p;
unsigned char	sw3p;
unsigned char	sw4p;

unsigned char	tun_flg;
unsigned int	kyoku_count;
unsigned int	vol_count;
unsigned int	rqst_rssi;
unsigned char	width;
unsigned char	wid_flg;

/*---------------------MAIN-----------------------*/
void	main(void)
{

	port_init();

	__delay_ms(2000);

	sw1_key=0;sw1_rep=0;sw1_cnt=0;
	sw2_key=0;sw2_rep=0;sw2_cnt=0;
	sw3_key=0;sw3_rep=0;sw3_cnt=0;
	sw4_key=0;sw4_rep=0;sw4_cnt=0;
	mode=0;preset_no=0;
	tun_flg=1;
	width=2;wid_flg=0;

	RA5=0;NOP();

	I2CInit();	

	lcd_init();
	lcd_clear();

	sw1p=RC0;NOP();
	sw2p=RC1;NOP();
	sw3p=RC2;NOP();
	sw4p=RC5;NOP();

	if((sw2p==0)&(sw3p==0)){
		eeprom_init();
	}
	else{
		eeprom_check();
	}

	si47xxAMSWLWRX_initialize();
    si47xx_getPartInformation();

	lcd_xy(0,0);
	lcd_print("ACARS   ");
	lcd_xy(0,1);
	lcd_print("TUNER   ");

	__delay_ms(1000);
   	lcd_xy(0,0);lcd_print("Si47    ");
   	lcd_xy(4,0);lcd_2keta10(partNumber);
   	lcd_xy(0,1);
   	lcd_data(fwMajor);
   	lcd_data(fwMinor);
   	lcd_data(cmpMajor);
   	lcd_data(cmpMinor);
   	lcd_data(chipRev);

	preset_set();

    si47xx_set_property(RX_HARD_MUTE, 0);
  	si47xx_set_property(RX_VOLUME, (u16)0 & RX_VOLUME_MASK);

	__delay_ms(1000);
	lcd_ini_disp();
	lcd_xy(0,1);lcd_print("        ");

	switch(mode){
		case 0:
				mhz_no=preset[preset_no];
				lcd_xy(1,0);lcd_mhz(mhz_no);
				tune_sub(mhz_no-FREQ_SA_AIR);rqst_rssi=1;
				lcd_mode(mode);
				break;
		case 1:	if(tun_flg==1){
					mhz_no=vol_yomi();
				}
				mhz_no_m=mhz_no;
				lcd_xy(1,0);lcd_mhz(mhz_no);
				tune_sub(mhz_no-FREQ_SA_AIR);rqst_rssi=1;
				lcd_ch_disp();
				lcd_mode(mode);
				break;
	}

	while(1){

		sw1p=RC0;NOP();
		sw2p=RC1;NOP();
		sw3p=RC2;NOP();
		sw4p=RC5;NOP();
	/* key scan 1 */
		if (sw1p==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if (sw2p==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if (sw3p==0){
				sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
			sw3_cnt=0;
		}
		/*------------------*/
		if (sw4p==0){
				sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
			sw4_cnt=0;
		}
		/*------------------*/

		wait_time(1000);

		sw1p=RC0;NOP();
		sw2p=RC1;NOP();
		sw3p=RC2;NOP();
		sw4p=RC5;NOP();
	/* key scan 2 */
		if ((sw1p==0)&&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if ((sw2p==0)&&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if ((sw3p==0)&&(sw3_key==0)){
			sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
			sw3_cnt=0;
		}
		/*------------------*/
		if ((sw4p==0)&&(sw4_key==0)){
			sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
			sw4_cnt=0;
		}
		/*------------------*/

	/* key action */
	
		if((sw1_key==0)&&(sw1_rep==0)){
			switch(mode){
				case 0:
						sw1_rep=1;
    					preset_no=preset_next(preset_no);
						mhz_no=preset[preset_no];
						lcd_xy(1,0);
						lcd_mhz(mhz_no);
						tune_sub(mhz_no-FREQ_SA_AIR);rqst_rssi=1;
						lcd_mode(mode);
						sw1_cnt=0;
						write_direct();
						break;
				case 1:	
						sw1_rep=1;

						break;						
			}
		}
		/*------------------*/

		if((sw2_key==0)&&(sw2_rep==0)){
			switch(mode){
				case 0:
						sw2_rep=1;
    					preset_no=preset_back(preset_no);
						mhz_no=preset[preset_no];
						lcd_xy(1,0);
						lcd_mhz(mhz_no);
						tune_sub(mhz_no-FREQ_SA_AIR);rqst_rssi=1;
						lcd_mode(mode);
						sw2_cnt=0;
						write_direct();
						break;
				case 1:
						sw2_rep=1;

						break;					
			}
		}
		/*--------------------*/
		if((sw3_key==0)&&(sw3_rep==0)){
			switch(mode){
				case 0:
						sw3_rep=1;
						mode=1;tun_flg=1;
						if(tun_flg==1){
							mhz_no=vol_yomi();
						}
						lcd_xy(1,0);
						lcd_mhz(mhz_no);
						tune_sub(mhz_no-FREQ_SA_AIR);rqst_rssi=1;
						lcd_ch_disp();
						lcd_mode(mode);
						write_direct();
						break;
				case 1:
						sw3_rep=1;
						mode=0;tun_flg=1;
						mhz_no=preset[preset_no];
						lcd_xy(1,0);
						lcd_mhz(mhz_no);
						tune_sub(mhz_no-FREQ_SA_AIR);rqst_rssi=1;
						lcd_mode(mode);
						write_direct();
						break;
			}
		}
		/*--------------------*/
		if((sw4_key==0)&&(sw4_rep==0)){
			switch(mode){
				case 1:	
						sw4_rep=1;
						switch(tun_flg){
							case 0:	tun_flg=1;
									break;
							case 1:	tun_flg=0;
									break;
						}
						lcd_mode(mode);
						break;	
				case 0:
						sw4_rep=1;
						switch(wid_flg){
							case 0:	wid_flg=1;
									lcd_width();
									rqst_rssi=RQST_RSSI_SHORT;
									break;
							case 1:	rqst_rssi=RQST_RSSI_SHORT;
									width++;
									if(width>4){width=0;}
									lcd_width();
									si47xx_set_property(AM_CHANNEL_FILTER, width);
									write_direct();
									break;
						}
						break;
			}
		}
		/*------------------*/

		/*------------------ */
		if((mode==1)&(tun_flg==1)){
		/*----------*/
			if(vol_count>0){vol_count--;}
			if(vol_count==0){
				mhz_no=vol_yomi();
				if(mhz_no>FREQ_MAX_AIR){mhz_no=FREQ_MAX_AIR;}
				if(mhz_no_m!=mhz_no){
					lcd_xy(1,0);
					lcd_mhz(mhz_no);
					tune_sub(mhz_no-FREQ_SA_AIR);rqst_rssi=1;
					lcd_ch_disp();
					lcd_mode(mode);
					mhz_no_m=mhz_no;
				}
				vol_count=VOL_COUNT_SET;
			}
		}
		/*------------------ */
		if(rqst_rssi>0){
			if(mode<2){
				rqst_rssi--;
				if(rqst_rssi==0){
					wid_flg=0;
					rqst_rssi=RQST_RSSI_INIT;
					amRsqStatus();
    				if(RSSI>99){RSSI=99;}
    				if(ASNR>99){ASNR=99;}
					lcd_xy(3,1);
					lcd_print("  S");
					lcd_2keta10(RSSI);
					if(RSSI>=MUTE_RSSI){
    					si47xx_set_property(RX_VOLUME, (u16)63 & RX_VOLUME_MASK);				
					}				
				}
			}
		}
		/**********************/


	/*------------------------*/




	}

}